#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <time.h>

#ifndef NetLoadD_MySQL_H
#define NetLoadD_MySQL_H

#define NetLoadD_Module_MySQL 1

#ifndef NetLoadD_Module_MySQL
#define NetLoadD_Module_MySQL 0

MYSQL* SQL_Connect(const char *server="localhost",const char *username="root",
	const char *password="marvin",const char *database="netload",
	const char *hname="lion.house.zz", const char *hhash="marvin") { return 0; }
int SQL_Post(unsigned long seconds, unsigned long period_rx, unsigned long period_tx,
	unsigned long total_rx, const char *device) { return 0; }
void SQL_Disconnect(MYSQL *s=0) { return; }



int NL_Module_MySQL=0;

#else
#include <mysql/mysql.h>

int NL_Module_MySQL=1;
char hostname[254]={0};
char hosthash[64]={0};
unsigned long hostkey=0;

MYSQL *sql;

MYSQL* SQL_Connect(const char *server="localhost",const char *username="root",
	const char *password="marvin",const char *database="netload",
	const char *hname="lion.house.zz", const char *hhash="marvin")
 {
 //printf("Connect called with for %s@%s/%s\n",server,username,password);
 sql=mysql_init(NULL);
 if (!sql) return 0;
 //printf("SQL Init");
 sql=mysql_real_connect(sql,server,username,password,database,0,NULL,0);
 if (!sql) return 0;
 //printf("Connection Success");
 // ToDO Here: Establish hostname and hosthash then get hostkey
 //strcpy(hostname,"lion.house.zz");
 //strcpy(hosthash,"marvin");
 char fq[1024];
 sprintf(fq,"SELECT hostkey FROM host WHERE hostname='%s' AND hash='%s'",hname,hhash);
 int res;
 //printf("\n%s\n",fq);
 res=mysql_query(sql,fq);
 if (res)
  {
  printf("SQL Error: Cannot Find Host or HostKeyHash in SELECT 1\n");
  return 0;
  }
 MYSQL_ROW sqlrow;
 MYSQL_RES *resptr;
 resptr=mysql_store_result(sql);
 if (!(sqlrow=mysql_fetch_row(resptr)))
  {
  printf("SQL Error: Cannot Find Host or KeyHash(2) in SELECT 1\n");
  return 0;
  }
 //printf("Hostkey found %s\n",sqlrow[0]);
 hostkey=atol(sqlrow[0]);
 return sql;
 }

void SQL_Disconnect(MYSQL *s=0)
 {
 if (s==0) s=sql;
 if (s<=0) return;
 mysql_close(s);
 s=0;
 }

int SQL_Post(unsigned long seconds, unsigned long period_rx, unsigned long period_tx,
	unsigned long total_rx, const char *device)
 {
 //if ( (sql<=0) || (hostname[0]==0) || (hosthash[0]==0) || (hostkey<=0) ) return 0;
 char Query[1024];
 for (int a=0; a<1024; a++) Query[a]=0;
 char td[1024];
 for (int z=0; z<1024; z++) td[z]=0;
 time_t timer;
 time(&timer);
 tm *g=gmtime(&timer);
 strftime(td,1024,"%Y-%m-%d %k:%M:%S",g);
 sprintf(Query,"%s(%s) VALUES(%lu,'%s','%s',%lu,%lu,%lu,%lu)",
	"INSERT INTO report",
	"hostkey,device,posted,seconds,period_rx,period_tx,total_rx",
	hostkey, device, td, seconds, period_rx, period_tx,
	total_rx);
 //printf("%s\n",Query);
 int res=mysql_query(sql,Query);
 if (!res) return 1;
 printf("Post Error %d: %s\n",mysql_errno(sql),mysql_error(sql));
 return 0;
 }
#endif
#endif

