#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <mysql/mysql.h>

#define AddHost_Version_Major 1
#define AddHost_Version_Minor 0
#define AddHost_Version_Release 2

void textversion(char *s)
 { sprintf(s,"%d.%d.%d\0", AddHost_Version_Major, AddHost_Version_Minor, AddHost_Version_Release ); }

void printversion(int name=0, int newline=0)
 {
 char v[32];
 textversion(v);
 if (name>1) printf("netloadd/");
 if (name>0) printf("addhost ");
 printf("%s",v);
 if (newline>0) printf("\n");
 }

MYSQL* SQL_Connect(const char *server="localhost",const char *username="root",
	const char *password="marvin",const char *database="netload")
 {
 //printf("Connect called with for %s@%s/%s\n",server,username,password);
 MYSQL *sql=mysql_init(NULL);
 if (!sql) return 0;
 //printf("SQL Init");
 sql=mysql_real_connect(sql,server,username,password,database,0,NULL,0);
 if (!sql) return 0;
 return sql;
 }

void SQL_Disconnect(MYSQL *s)
 {
 mysql_close(s);
 s=0;
 }

int main(int ac, char **av)
 {
 printversion(2,1);
 if (ac!=7)
  {
  printf("Usage %s DB_Server DB_Username DB_Password Database Hostname
 	Hosthash\n",av[0]);
  printf("Use %s -? for more information\n\n");
  return 0;
  }
 MYSQL *s=SQL_Connect(av[1],av[2],av[3],av[4]);
 if (!s)
  {
  printf("Error connecting!\n");
  return 0;
  }
 char q[1024];
 sprintf(q,"INSERT INTO host(hostname,hash) VALUES('%s','%s')",
	av[5],av[6]);
 mysql_query(s,q);
 printf("Query Completed\n");
 SQL_Disconnect(s);
 return 0;
 }
